#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <string.h>

#define pb push_back

using namespace std;

typedef long long LL;

LL memo[18][30][19][13][11];

int f[4] = { 2, 3, 5, 7 };
int k[4];
int code[10][4] = {
   { 0, 0, 0, 0 },
   { 0, 0, 0, 0 },
   { 1, 0, 0, 0 },
   { 0, 1, 0, 0 },
   { 2, 0, 0, 0 },
   { 0, 0, 1, 0 },
   { 1, 1, 0, 0 },
   { 0, 0, 0, 1 },
   { 3, 0, 0, 0 },
   { 0, 2, 0, 0 }
};

LL rec( int digits, LL a, LL pot, LL lo, LL hi ) {
   LL b = a + pot-1;
   if( a > hi || b < lo ) return 0;
   if( digits == 18 ) return !k[0] && !k[1] && !k[2] && !k[3];

   int memoize = 0;
   if( a >= lo && b <= hi ) memoize = 1;

   if( memoize && memo[digits][k[0]][k[1]][k[2]][k[3]] >= 0 )
      return memo[digits][k[0]][k[1]][k[2]][k[3]];

   pot /= 10;

   LL ret = 0;

   for( int digit = (a!=0); digit <= 9; ++digit ) {

      int ok = 1;
      for( int i = 0; i < 4; ++i ) ok &= code[digit][i] <= k[i];
      if( !ok ) continue;

      for( int i = 0; i < 4; ++i ) k[i] -= code[digit][i];
      ret += rec( digits+1, a + digit*pot, pot, lo, hi );
      for( int i = 0; i < 4; ++i ) k[i] += code[digit][i];
   }

   if( memoize ) memo[digits][k[0]][k[1]][k[2]][k[3]] = ret;

   return ret;
}

LL lo, hi;
LL res;

LL ceil( LL a, LL b ) { return (a+b-1)/b; }
LL floor( LL a, LL b ) { return a/b; }

void gen( LL limit, LL product, int factor ) {
   if( product > 1000000000 || product*product > limit ) return;
   if( factor == 4 ) {
      res += rec( 0, 0, 1000000000000000000LL, ceil(lo,product), floor(hi,product) );
      return;
   }

   gen( limit, product, factor + 1 );
   ++k[factor];
   gen( limit, product*f[factor], factor );
   --k[factor];
}

void init() {
	lo = hi = 0;
	res = 0;

	memset(k, 0, sizeof(k));
}

LL solve(LL a, LL b) {
	init();

	lo = a;
	hi = b;

	memset( memo, -1, sizeof memo );

	gen( hi, 1, 0 );

	return res;
}

int main()
{
	freopen("function.in", "r", stdin);
	freopen("function.out", "w", stdout);

	LL L, n, R;
	cin >> L >> n;

	LL le = L, ri = 1000000000000000000LL, mid;
	while(le <= ri) {
		mid = (le + ri) >> 1;
		LL cur = solve(L, mid);
		if(cur >= n) {
			R = mid;
			ri = mid - 1;
		}
		else le = mid + 1;
	}

	cout << R << endl;

    return 0;
}
